Skip to content
Start here

Import SQL into your D1 Database

d1.database.import_(strdatabase_id, DatabaseImportParams**kwargs) -> DatabaseImportResponse
POST/accounts/{account_id}/d1/database/{database_id}/import

Generates a temporary URL for uploading an SQL file to, then instructing the D1 to import it and polling it for status updates. Imports block the D1 for their duration.

Security
API Token

The preferred authorization scheme for interacting with the Cloudflare API. Create a token.

Example:Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY
API Email + API Key

The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

Example:X-Auth-Email: user@example.com

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

Example:X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194
ParametersExpand Collapse
account_id: str

Account identifier tag.

maxLength32
database_id: str

D1 database identifier (UUID).

action: Literal["init"]

Indicates you have a new SQL file to upload.

etag: str

Required when action is 'init' or 'ingest'. An md5 hash of the file you're uploading. Used to check if it already exists, and validate its contents before ingesting.

ReturnsExpand Collapse
class DatabaseImportResponse:
at_bookmark: Optional[str]

The current time-travel bookmark for your D1, used to poll for updates. Will not change for the duration of the import. Only returned if an import process is currently running or recently finished.

error: Optional[str]

Only present when status = 'error'. Contains the error message that prevented the import from succeeding.

filename: Optional[str]

Derived from the database ID and etag, to use in avoiding repeated uploads. Only returned when for the 'init' action.

messages: Optional[List[str]]

Logs since the last time you polled

result: Optional[Result]

Only present when status = 'complete'

final_bookmark: Optional[str]

The time-travel bookmark if you need restore your D1 to directly after the import succeeded.

meta: Optional[ResultMeta]
changed_db: Optional[bool]

Denotes if the database has been altered in some way, like deleting rows.

changes: Optional[float]

Rough indication of how many rows were modified by the query, as provided by SQLite's sqlite3_total_changes().

duration: Optional[float]

The duration of the SQL query execution inside the database. Does not include any network communication.

last_row_id: Optional[float]

The row ID of the last inserted row in a table with an INTEGER PRIMARY KEY as provided by SQLite. Tables created with WITHOUT ROWID do not populate this.

rows_read: Optional[float]

Number of rows read during the SQL query execution, including indices (not all rows are necessarily returned).

rows_written: Optional[float]

Number of rows written during the SQL query execution, including indices.

served_by_colo: Optional[str]

The three letters airport code of the colo that handled the query.

served_by_primary: Optional[bool]

Denotes if the query has been handled by the database primary instance.

served_by_region: Optional[Literal["WNAM", "ENAM", "WEUR", 3 more]]

Region location hint of the database instance that handled the query.

One of the following:
"WNAM"
"ENAM"
"WEUR"
"EEUR"
"APAC"
"OC"
size_after: Optional[float]

Size of the database after the query committed, in bytes.

timings: Optional[ResultMetaTimings]

Various durations for the query.

sql_duration_ms: Optional[float]

The duration of the SQL query execution inside the database. Does not include any network communication.

num_queries: Optional[float]

The total number of queries that were executed during the import.

status: Optional[Literal["complete", "error"]]
One of the following:
"complete"
"error"
success: Optional[bool]
type: Optional[Literal["import"]]
upload_url: Optional[str]

The R2 presigned URL to use for uploading. Only returned when for the 'init' action.

Import SQL into your D1 Database

import os
from cloudflare import Cloudflare

client = Cloudflare(
    api_token=os.environ.get("CLOUDFLARE_API_TOKEN"),  # This is the default and can be omitted
)
response = client.d1.database.import_(
    database_id="xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx",
    account_id="023e105f4ecef8ad9ca31a8372d0c353",
    action="init",
    etag="etag",
)
print(response.at_bookmark)
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "at_bookmark": "at_bookmark",
    "error": "error",
    "filename": "filename",
    "messages": [
      "string"
    ],
    "result": {
      "final_bookmark": "final_bookmark",
      "meta": {
        "changed_db": true,
        "changes": 0,
        "duration": 0,
        "last_row_id": 0,
        "rows_read": 0,
        "rows_written": 0,
        "served_by_colo": "LHR",
        "served_by_primary": true,
        "served_by_region": "EEUR",
        "size_after": 0,
        "timings": {
          "sql_duration_ms": 0
        }
      },
      "num_queries": 0
    },
    "status": "complete",
    "success": true,
    "type": "import",
    "upload_url": "upload_url"
  },
  "success": true
}
Returns Examples
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "at_bookmark": "at_bookmark",
    "error": "error",
    "filename": "filename",
    "messages": [
      "string"
    ],
    "result": {
      "final_bookmark": "final_bookmark",
      "meta": {
        "changed_db": true,
        "changes": 0,
        "duration": 0,
        "last_row_id": 0,
        "rows_read": 0,
        "rows_written": 0,
        "served_by_colo": "LHR",
        "served_by_primary": true,
        "served_by_region": "EEUR",
        "size_after": 0,
        "timings": {
          "sql_duration_ms": 0
        }
      },
      "num_queries": 0
    },
    "status": "complete",
    "success": true,
    "type": "import",
    "upload_url": "upload_url"
  },
  "success": true
}